// Generated by CoffeeScript 1.7.1
(function() {
  var Riak, riak;

  riak = require("riak-js");

  module.exports = Riak = (function() {
    function Riak(options) {
      this.options = options;
      this.client = riak.getClient(this.options);
    }

    Riak.prototype.write = function(key, data, callback) {
      return this.client.save(this.options.bucket, key, data, callback);
    };

    Riak.prototype.read = function(key, callback) {
      return this.client.get(this.options.bucket, key, callback);
    };

    Riak.prototype["delete"] = function(key, callback) {
      return this.client.remove(this.options.bucket, key, callback);
    };

    Riak.prototype.keys = function(callback) {
      var results, stream;
      results = [];
      stream = this.client.keys(this.options.bucket, {
        keys: "stream"
      }, function(error) {
        if (error != null) {
          return callback(error);
        } else {
          return callback(null, results);
        }
      });
      stream.on("keys", function(keys) {
        var key, _i, _len, _results;
        _results = [];
        for (_i = 0, _len = keys.length; _i < _len; _i++) {
          key = keys[_i];
          _results.push(results.push(key));
        }
        return _results;
      });
      return stream.start();
    };

    return Riak;

  })();

}).call(this);
